function [aovals2,maovals2,yav2,ogap2]=ColStochGrad(Amat,bvec,cvec,n,maxiter,alpha,ps,B,checkf)
y=zeros(size(Amat,1),1);yav2=y;aovals2=[];maovals2=[];minaovals2=[];diagn=[];
hv=alpha/sqrt(maxiter);
Nperiod=floor(maxiter/checkf);ogap2=[];
c=floor(ps*n);
for k=0:maxiter
    % Compute approx eigenvector
    covm=reshape(Amat'*y-cvec,n,n);
    pp=sum(covm.^2)'/norm(covm,'fro')^2;
    cp=PartialSum(pp);
    rv=rand(1,c); 
    idxc=[];
    for i=1:c
        idxc=[idxc,min(find(rv(i)<=cp))];
    end
    C=covm(:,idxc)*diag(1./sqrt(c*pp(idxc)));
    Sm=C'*C;
    %[vv,sigmav]=maxeig(Sm);
    [vv,sigmav]=lmeig(Sm);
    %[vv,sigmav,nconv]=SpMaxEig(Sm,1,1,1e-6,300);
    up=C*vv/sqrt(sigmav);sigma=sqrt(sigmav); 
    umv=vec(up*up');
    % Construct Approx. Gradient
    switch 2
        case 1,
            swsgn=sign(up'*covm*up);
            sqa=sum(Amat.^2)';sqb=(umv.^2);
            pp2=sqrt(sqa.*sqb)/sum(sqrt(sqa.*sqb));
            psp=2*ps;
            c=floor(psp*n);
            cp2=PartialSum(pp2);
            rv=rand(1,c);idxc2=[];
            for i=1:c
                idxc2=[idxc2,min(find(rv(i)<=cp2))];
            end
            grad=swsgn*Amat(:,idxc2)*((1./(c*pp2(idxc2))).*umv(idxc2))-bvec;
        case 2,
            swsgn=sign(up'*covm*up);
            colidx=vec(ones(n,1)*(idxc-1)*n+(1:n)'*ones(1,c));
            scalv=kron((c*pp(idxc)),ones(n,1));
            grad=swsgn*Amat(:,colidx)*(umv(colidx)./scalv)-bvec;
        case 3,
            colidx=vec(ones(n,1)*(idxc-1)*n+(1:n)'*ones(1,c));
            scalv=kron((c*pp(idxc)),ones(n,1));
            swsgn=sign(Amat(:,colidx)*(umv(colidx)./scalv));
            buf=cvec(colidx)'*(umv(colidx)./scalv);
            gprd=Amat(:,colidx)*(umv(colidx)./scalv);
            swsgn=sign(y'*gprd-buf);
            grad=swsgn*gprd-bvec;
        case 4,
            swsgn=sign(up'*covm*up);
            grad=swsgn*Amat*umv-bvec;
    end
    if 0 % Diagnostics
        [tu,tsigma]=lmeig(reshape(Amat'*y-cvec,n,n));
        diagn=[diagn;[tsigma,sigma,abs(tu'*up)]];
        if abs(tu'*up)<0.1
            badmat=reshape(Amat'*yav2-cvec,n,n);
        end
    end
    % Record function value
    aovals2=[aovals2,abs(sigma)-bvec'*y];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav2=(k*yav2+y)/(k+1);
    % Gap
    ogap2=[ogap2;(abs(sigma)-bvec'*yav2)-dualvalue(Amat,bvec,cvec,vec(umv),B)];
    % Check progress
    if mod(k,Nperiod)==0
        [avu,avsigma]=lmeig(reshape(Amat'*yav2-cvec,n,n));
        maovals2=[maovals2;abs(avsigma)-bvec'*yav2];
        disp(sprintf('Iteration: %d',k));
    end
end