% Teststoch max. eig. minimization code
addpath('../Data');
addpath('../');

if 0
load covmedium
[s,idx]=sort(diag(covmedium),'descend');
end

% Sample parameters
ns=[500,750,1000,1500,2000];
%ns=[200,500];


% ***** Algo parameters *****
maxiter=200;
checkf=10;
ps=0.2; 
bnd=0.5;
alpha=1;
iterfac=2*floor(1/ps);
rand('state',11);
% ***************************


res=[];
for n=ns
        covm=covmedium(idx(1:n),idx(1:n));
        covm=covm/norm(covm);
        % Launch codes. 
        disp('Deterministic gradient')
        tic;[X2,Xav2,ovals2,movals2,gaps2,cput2]=DetDSPCA(covm,bnd,alpha,maxiter,checkf,0);t2=toc;
        idx2=find(movals2);movals2=movals2(idx2);gaps2=gaps2(idx2)/gaps2(1);
        disp('Subsampled gradient')
        tic;[X1,Xav1,ovals1,movals1,gaps1,cput1]=ColDSPCA(covm,bnd,ps,alpha,iterfac*maxiter,0.5*iterfac*checkf,min(movals2));t1=toc;
        idx1=find(movals1);movals1=movals1(idx1);gaps1=gaps1(idx1)/gaps1(1);
        res=[res;[n,t1,t2]];
        disp('**********************************************************************************');
        disp([n,t2/t1,res(end,:)]);
        disp('**********************************************************************************');
end


cpu1=res(:,2);
cpu2=res(:,3);
[ns',cpu2./cpu1]

latex([ns',cpu2,cpu1,cpu2./cpu1],'%.2e')


if 0
    it=(0:checkf)*(maxiter/checkf);
    semilogy(cput1(idx1),gaps1,'-bo',cput2(idx2),gaps2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
    semilogy(cput1(idx1),movals1,'-bo',cput2(idx2),movals2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
    semilogy(0:length(ovals1)-1,ovals1,'-b',0:length(ovals2)-1,ovals2,'-k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
end


