% Test Subsampling quality and link with numerical rank

addpath('../Data');
addpath('../');

n=500;

if 0 % Get Colon matrix
load CovColon
covt=covcolon;
n=500;
pp=sum(covt.^2)'/norm(covt,'fro')^2;
cp=PartialSum(pp);
rv=rand(1,c);
idxc=[];
for i=1:c
    idxc=[idxc,min(find(rv(i)<=cp))];
end
C=covt(:,idxc)*diag(1./sqrt(c*pp(idxc)));
Sm=C'*C;
%[vv,sigmav]=maxeig(Sm);
[vv,sigmav]=lmeig(Sm);
[v2,truesig]=lmeig(covt);
numr=norm(covt,'fro')^2/truesig^2;
rescolon=[sqrt(sigmav),truesig,r,numr];
colerr=(sqrt(sigmav)-truesig)^2/truesig^2;
rescolon(4);
end


if 1
% Parameters    
nsamp=50;
ranks=[1:0.25:5,5:20];
%ranks=1:100;
bfac=1/n;
ps=.2;
c=floor(ps*n);
confl=0.01;
eta=1+sqrt(8*log(1/confl));

% Eig decomposition of orig. matrix
[V,D]=eig(covm);
[d,idx]=sort(diag(D),'Descend');
dbis=diag(D);dbis=dbis(randperm(n));

res=[];
for r=ranks
    for s=1:nsamp
        %idr=randperm(n);
        %covt=V*diag([dbis(idr(1:r));zeros(n-r,1)])*V'; % From gene expression matrix
        %[V,R]=qr(randn(n,n));covt=V*diag(exp(-bfac*r*(1:n)).*rand(1,n))*V'; % Random matrix 
        %[V,R]=qr(randn(n,n));covt=V*diag(exprnd(1/bfac*r,n,1))*V'; % Random matrix 
        [V,R]=qr(randn(n,n));covt=V*diag(betarnd(bfac*r,1,n,1))*V'; % Random matrix 
        pp=sum(covt.^2)'/norm(covt,'fro')^2;
        cp=PartialSum(pp);
        rv=rand(1,c);
        idxc=[];
        for i=1:c
            idxc=[idxc,min(find(rv(i)<=cp))];
        end
        C=covt(:,idxc)*diag(1./sqrt(c*pp(idxc)));
        Sm=C'*C;
        %[vv,sigmav]=maxeig(Sm);
        [vv,sigmav]=lmeig(Sm);
        [v2,truesig]=lmeig(covt);
        numr=norm(covt,'fro')^2/truesig^2;
        res=[res;sqrt(sigmav),truesig,r,numr];
    end
end

% Check relative error
errv=sqrt((res(:,1)-res(:,2)).^2./res(:,2).^2);
ixnz=find(errv>1e-10); % Remove outliers with very small error
% Get coefficient of regression and ratio theor/empirical
theoerr=eta*res(:,4)/sqrt(c);
erratio=sqrt(errv)./theoerr;
intv=(-3.9:.035:-1.2)';
nout=hist(erratio,10.^intv);
semilogx(10.^intv,zeros(length(intv),1));hold on;
set(gca,'XScale','log');
bar_handle=bar(10.^intv,nout,'hist');
set(bar_handle,'MarkerSize',25);
set(gca,'FontSize',16);xlabel('erratio');ylabel('occur');hold off;
Am=[res(ixnz,4),ones(length(ixnz),1)];
beta=Am\sqrt(errv(ixnz));
shft=mean(log10(errv(ixnz)./(res(ixnz,4))));
% Plot results
figure
loglog(res(ixnz,4),errv(ixnz),'.','MarkerSize',12);hold on;
loglog([0.75*min(res(ixnz,4)),1.2*max(res(ixnz,4))],10^shft*[min(res(ixnz,4)),max(res(ixnz,4))],'LineStyle','--','Linewidth',4,'Color',[0 0 0])
loglog([rescolon(4),rescolon(4)+1e-8],[colerr,colerr],'-rs','MarkerSize',15,'MarkerFaceColor','r','MarkerEdgeColor','k')
axis([0.9*min(res(ixnz,4)) 1.1*max(res(ixnz,4)) 1e-1*min(errv(ixnz)) 2*max(errv(ixnz))]);hold off;
set(gca,'FontSize',16);xlabel('numrank');ylabel('relerr');
end