% Teststoch trace norm minimization
addpath('./Data');

% Get data
n=500;
load covmedium
[s,idx]=sort(diag(covmedium),'descend');
covm=covmedium(idx(1:n),idx(1:n));


% ***** Algo parameters *****
maxiter=500;
checkf=10;
ps=0.2;
alpha=1; 
bnd=0.5;
iterfac=2*floor(1/ps);
rand('state',11);
% ***************************


if 1 % Approx subgradient MATLAB code with columnwise subsampling
covm=covm/norm(covm);
disp('Deterministic gradient')
[X2,Xav2,ovals2,movals2,gaps2,cput2]=DetDSPCA(covm,bnd,alpha,maxiter,checkf,0);
idx2=find(movals2);movals2=movals2(idx2);gaps2=gaps2(idx2);
disp('Subsampled gradient')
[X1,Xav1,ovals1,movals1,gaps1,cput1]=ColDSPCA(covm,bnd,ps,alpha,iterfac*maxiter,0.5*iterfac*checkf,min(movals2));
idx1=find(movals1);movals1=movals1(idx1);gaps1=gaps1(idx1);
end


if 0 % Plot results
plot(cput1(idx1),movals1,'-bo',cput2(idx2),movals2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
set(gca,'FontSize',16);
xlabel('cpu');ylabel('oval');
plot(cput1(idx1),gaps1,'-bo',cput2(idx2),gaps2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
set(gca,'FontSize',16);
xlabel('cpu');ylabel('gap');
end