% Teststoch trace norm minimization
addpath('./Data');


if 1 % Generate sample ratings data
rand('state',1);
n=100;
r=3;
nrts=4;
observ=0.3;
U=round(sqrt(nrts)*rand(n,r));
Aorig=U*U';
tidx=find(triu(ones(n,n)));
obidx=tidx(randperm(length(tidx)));obidx=obidx(1:floor(observ*length(tidx)/2));
A=zeros(n,n);A(obidx)=Aorig(obidx);A=A+tril(A',-1);
end


% ***** Algo parameters *****
maxiter=5000;
checkf=10;
ps=0.2;
alpha=1; 
B=10;
rnk=4;
iterfac=2*floor(1/ps);
% ***************************


if 1 % Approx subgradient MATLAB code with columnwise subsampling
%[X,Xav,ovals]=StochGradSumKLarg(A,r,maxiter,alpha,ps,B,checkf,0); % MATLAB version
As=sparse(A);
disp('Deterministic gradient')
[X2,Xav2,ovals2,movals2,gaps2,cput2]=DetTraceNorm(As,rnk,B,alpha,maxiter,checkf,0);
idx2=find(movals2);movals2=movals2(idx2);gaps2=gaps2(idx2);
disp('Subsampled gradient')
[X1,Xav1,ovals1,movals1,gaps1,cput1]=ColTraceNorm(As,rnk,B,ps,alpha,maxiter*iterfac,checkf,min(movals2));
idx1=find(movals1);movals1=movals1(idx1);gaps1=gaps1(idx1);
end


if 0 % Plot results
% sum(sum(abs(round(Xav1)-A)>0));spy(round(Xav1)-A)
% [svd(A),svd(Xav1)]
% plot(1:n,svd(A),'-k.',1:n,svd(Xav1),'-bo');axis([1 n 1e-1*max(svd(A)) 1.1*max(svd(A))])
[norm(A,'fro')^2/norm(A)^2,norm(Xav1,'fro')^2/norm(Xav1)^2]
plot(cput1(idx1),movals1,'-bo',cput2(idx2),movals2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
set(gca,'FontSize',16);
xlabel('cpu');ylabel('oval');
plot(cput1(idx1),gaps1,'-bo',cput2(idx2),gaps2,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
set(gca,'FontSize',16);
xlabel('cpu');ylabel('gap');
end